2025-01-04 Petasis George  <petasis@iit.demokritos.gr>
        * win/OleDND.h: Improved support for Tcl 9. (Pull request by Github
	user apnadkarni - https://github.com/petasis/tkdnd/pull/72).

2025-01-02 Petasis George  <petasis@iit.demokritos.gr>
        * TkDND 2.9.5 has been released.

        * demos/dndSpy.tcl:
        * library/tkdnd.tcl:
        * library/tkdnd_unix.tcl:
        * library/tkdnd_windows.tcl:
        * win/OleDND.h:
        * win/TkDND_OleDND.cpp:
        * win/makefile.vc:
        * win/rules-ext.vc: Added support for Tcl 9. (Pull request by Github
	user apnadkarni - https://github.com/petasis/tkdnd/pull/70).

2025-01-01 Petasis George  <petasis@iit.demokritos.gr>
        * configure.ac: Fix includes when the working directory is not in the
	source directory. (Pull request by Github user chpock - https://github.com/petasis/tkdnd/pull/63).

        * macosx/macdnd.m: Fix macOS version name in comment. (Pull request by
	Github user chrstphrchvz - https://github.com/petasis/tkdnd/pull/62).

2024-01-24 Petasis George  <petasis@iit.demokritos.gr>
        * TkDND 2.9.4 has been released.

2023-12-29 Petasis George  <petasis@iit.demokritos.gr>
        * README.md: Updated required Tcl/Tk versions. Tk 8.3.3 has been
        dropped, TkDND now requires 8.4 on Windows/Linux, and 8.5 for macOS.

        * library/tkdnd_macosx.tcl:
        * macosx/macdnd.m: Fixed deprecations introduced in macOS 10.13.

2023-12-27 Petasis George  <petasis@iit.demokritos.gr>
        * .travis.yml: Restored travis CI operation, and added an additional
        CI for macOS (macOS 10.13 - High Sierra - OS shipped Tcl/Tk - 8.5 &
        macOS 12.06 - Monterey - Homebrew Tcl/Tk 8.6.13+).

        * configure.ac:
        * tclconfig/*: Updated to the latest Tcl config package.

        * generic/TkDND_Cursors.c:
        * library/tkdnd.tcl:
        * macosx/macdnd.m:
        * unix/TkDND_XDND.c:
        * win/OleDND.h
        * win/TkDND_OleDND.cpp: Initial updates for Tcl 8.7 and 8.9 contributed by Paul Obermeier.

2022-12-12 Petasis George  <petasis@iit.demokritos.gr>
        * tests/bug40.tcl: Added a test case for bug 40.

2022-12-10  Petasis George  <petasis@iit.demokritos.gr>
        * demos/simple_target.tcl: Wrapped the drop target inside a
        ttk::frame, to test if events are received by windows inside windows
        that are not drop targets.

2021-09-01  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_utils.tcl: Fixed bug #55.
        * CMakeLists.txt: Fix so as a correct pkgIndex.tcl is generated (by
        reading pkgIndex.tcl.in).

2020-09-19  Petasis George  <petasis@iit.demokritos.gr>
        * configure:
        * configure.ac: Added flag -static-libstdc++ when building with gcc
        under Windows.

        * .appveyor.yml: Build also with MSYS2 under Windows.
        * appveyor_build_msys2.sh: Build script for MSYS2.

2020-08-19  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_unix.tcl: Fixed bug #40.

        * pkgIndex.tcl.in:
        * CMakeLists.txt:
        * library/tkdnd.tcl: Added the option for enabling debug messages
        through the global variable ::TKDND_DEBUG_LEVEL (before loading the
        package).

2020-08-18  Petasis George  <petasis@iit.demokritos.gr>
        * .travis.yml: Added installation of libxcursor1 and libxcursor-dev.

        * configure.ac: Added checks for lib Xcursor.

        * library/tkdnd_generic.tcl: Fixed bug #44, where "string is entier"
        may not be available.

        * library/tkdnd_generic.tcl: Fixed bug #43, renamed
        ::tkdnd::platform_independent_types to
        generic::platform_independent_types.

2020-03-03  Petasis George  <petasis@iit.demokritos.gr>
        * CMakeLists.txt:
        * configure.ac:
        * unix/Cursors.c: Corrections in build system and fixed some warnings
        under unix.

2020-02-23  Petasis George  <petasis@iit.demokritos.gr>
        * demos/custom_cursors.tcl:
        * demos/cursors: Added a demo script for shwoing the interface for
        custom cursors.

        * generic/*: Moved cursor utilities from unix to the generic folder.
        * unix/Cursors.c: TkDND_GetCursor moved in generic.
        Added support for custom cursors.

2019-07-15  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd.tcl: Allowed ::tkdnd::drag_source to accept multiple
        mouse buttons, as the event that initiates a drag action.

        * library/tkdnd.tcl: Merged pull request #36.
        (https://github.com/petasis/tkdnd/pull/36).

        * unix/TkDND_XDND.c: Changed how TkDND_GetToplevelFromWrapper()
        selects the topelvel. Patch from Florian Pigorsch.
        (https://github.com/petasis/tkdnd/issues/34)

2019-07-14  Petasis George  <petasis@iit.demokritos.gr>
        * doc/tkDND.n:
        * doc/tkDND.htm: Updated documentation to reflect the changes in the
        %b and %m binding substitutions.

2019-07-13  Petasis George  <petasis@iit.demokritos.gr>
        * CMakeLists.txt:
        * configure.ac: Added checks for X11/XKBlib.h, defining
        HAVE_X11_EXTENSIONS_XKB_H if found.

        * demos/dndSpy.tcl: Updated the demo code to show pressed mouse buttons
        and modifier keys.

        * library/tkdnd_generic.tcl: Fixed Bug #35, where mouse buttons were
        reported together with modifier keys:
        (https://github.com/petasis/tkdnd/issues/35)

        * library/tkdnd_unix.tcl: Fixes for using the new
        "_keyboard_get_state", and correctly report the pressed mouse keys and
        modifiers.

        * unix/TkDND_XDND.c: Added support for the Xkb extension, and added
        support (and a new Tcl-level command, "_keyboard_get_state") for
        getting the pressed mouse buttons/modifiers under Unix. This relates
        to Bug #35 (https://github.com/petasis/tkdnd/issues/35). However,
        under Unix, the drop target is not supposed to decide on the action:
        it is the drag source that takes this decision. The drop target must
        either accept the action provided by the drag source, or replay with
        "copy" or "ask". This must be reflected in the documentation.

2019-07-12  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_unix.tcl:
        * library/tkdnd_generic.tcl: Added a new parameter for drag source
        action on HandlePosition.

        * unix/TkDND_XDND.c: TkDND_HandleXdndEnter() also passes the action
        requested by the drag source to tkdnd::xdnd::HandleXdndEnter.

        * unix/TkDND_XDND.c: Fix in TkDND_GetToplevelFromWrapper(), to take
        into account a menu, if it exists. Fixed bug #34:
        (https://github.com/petasis/tkdnd/issues/34)

2019-06-13  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_generic.tcl: Removed usage of "{*}" for better Tcl 8.4
        compatibility.

2019-06-09  Petasis George  <petasis@iit.demokritos.gr>
        * doc/tkDND.n: Documented %x, %y binding keywords.

        * library/tkdnd_generic.tcl: Added feature request #31:
        (https://github.com/petasis/tkdnd/issues/31)

        * library/tkdnd_utils.tcl:
        * library/tkdnd_generic.tcl: Fixed bug #33:
        (https://github.com/petasis/tkdnd/issues/33)

        * library/tkdnd.tcl: Fixed bug #30:
        (https://github.com/petasis/tkdnd/issues/30)
        Fixed bug #32:
        (https://github.com/petasis/tkdnd/issues/32)

2019-04-16  Petasis George  <petasis@iit.demokritos.gr>
        * Version 2.9.2 released.

        * demos/basic.tcl: Merged pull request #29.
        (https://github.com/petasis/tkdnd/pull/29)

        * configure.ac: configure reads version from VERSION. Added
        TEA_PATH_X, to link with the X11 library. Fixed bug #27.
        (https://github.com/petasis/tkdnd/issues/27)

        * VERSION:
        * CMakeLists.txt: Added a VERSION file. CMake reads version from this
        file. Merged pull request #28.
        (Fixes bug #26 https://github.com/petasis/tkdnd/issues/26).

2019-02-03  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd.tcl: Added conversion from utf-8 in
        ::tkdnd::urn_unquote.

        * library/tkdnd_unix.tcl: Added support for comments in
        xdnd::normalise_data for the "text/uri-list" media type.

        * demos/dndSpy.tcl: Modified demo to also show data to be dropped
        during drag.

        * win/OleDND.h:
        * unix/TkDND_XDND.c
        * library/tkdnd_generic.tcl:
        * library/tkdnd_macosx.tcl:
        * library/tkdnd_unix.tcl:
        * library/tkdnd_windows.tcl: Provided a solution for bug #25.
        Under Windows and Unix, the dropped data is available for the
        <<DropEnter>> and <<DropPosition>> events (%D specifier).

2018-12-23  Petasis George  <petasis@iit.demokritos.gr>
        * .travis.yml: make install & deployment to GitHub.

        * .appveyor.yml: Set tclsh for IronTcl. Deployment to GitHub.

2018-12-22  Petasis George  <petasis@iit.demokritos.gr>
        * .appveyor.yml: Added a command to install project after build.

2018-12-07  Petasis George  <petasis@iit.demokritos.gr>
        * tcl-conf: More tweaks for finding tcl config and header files in
        OS X 10.14.

2018-12-02  Petasis George  <petasis@iit.demokritos.gr>
        * demos/text_widget_demo.tcl: New demo, demonstrating tkdnd::utils for
        the text widget.

        * library/tkdnd_utils.tcl: Added a new package (tkdnd::utils) with
        utility functions (i.e. ::tkdnd::text::drag_source/
        ::tkdnd::text::drop_target that can be used for text widgets,
        to facilitate drag/drop in such widgets).

        * library/tkdnd.tcl: Fixes in ::tkdnd::drag_source(): The TkDND_Drag
        binding tag is now placed before the widget class.
        **** POTENTIAL INCOMPATIBILITY **** for applications relying on the
        previous behaviour (the tag was added as the last one).

        * library/tkdnd_compat.tcl: Fixes for the TkDND 1.x compatibility layer.

        * library/tkdnd_windows.tcl: Fixed two typos.

        * win/TkDND_OleDND.cpp: Fixed a bug in TkDND_DoDragDropObjCmd(), where
        Tcl_SetResult() was not used correctly. Calles changed to
        Tcl_SetObjResult().

        * win/TkDND_OleDND.h: Fixed a memory leak in Drop(), where
        Tcl_IncrRefCount() was called instead of the correct
        Tcl_DecrRefCount().

2018-10-28  Petasis George  <petasis@iit.demokritos.gr>
        * demos/basic.tcl: Added a drag source that sends an empty string.

        * macosx/macdnd.m: Fixed bug #21
        (https://github.com/petasis/tkdnd/issues/21), where an image of size
        (0, 0) was created, if the data to be pasted was an empty string.

2018-10-10  Petasis George  <petasis@iit.demokritos.gr>
        * demos/dndSpy.tcl:
        * doc/tkDND.htm:
        * library/tkdnd_unix.tcl:
        * macosx/macdnd.m:
        * unix/TkDND_XDND.c:
        * win/Makefile:
        * win/OleDND.h: Merged pull request #20 "Fix some typos.", by Github
        user flopp.

2018-07-23  Petasis George  <petasis@iit.demokritos.gr>
        * README.md: Added a small experiment about Travis CI integration.

2018-07-22  Petasis George  <petasis@iit.demokritos.gr>
        * macosx/macdnd.m: Updated code to use the new (10.7+) API. Possible
        incompatibility: A file(s) drag will not start if any of the provided
        paths is not an absolute path.

2018-07-12  Petasis George  <petasis@iit.demokritos.gr>
        * macosx/macdnd.m: Temporarily disabled the new drag source code for
        macOS 10.7+, as it does not seem to work in simple tests.

2018-07-12  Petasis George  <petasis@iit.demokritos.gr>
        * macosx/macdnd.m: Merged pull request #4:
        * CMakeLists.txt:  Added compatibility for later OS X versions.
        * configure.ac:    https://github.com/petasis/tkdnd/pull/4
        Actually this pull request resolved the deprecation of
        "dragImage:at:offset:event:pasteboard:source:slideBack:" I failed to
        address in the previous update of macosx/macdnd.m.

        * win/Makefile: Merged pull request #5: Updated Windows version number.
        https://github.com/petasis/tkdnd/pull/5

        * demos/dndSpy.tcl: Merged pull request #10: Added executable flag to
        demo with shebang line.
        https://github.com/petasis/tkdnd/pull/10

        * Changelog: Merged pull request #15:
        https://github.com/petasis/tkdnd/pull/15

2018-07-11  Petasis George  <petasis@iit.demokritos.gr>
        * tcl-conf: Added more checks, needed for macOS.

        * macosx/macdnd.m: macOS 10.7/10.12/10.13 deprecated some definitions (
        NSDragPboard, NSLeftMouseDragged, NSLeftMouseDownMask) and some
        functions (convertScreenToBase) we use. Alternatives have been used.
        "dragImage:at:offset:event:pasteboard:source:slideBack:" is also
        deprecated in 10.7, but is more difficult to be replaced.

2018-06-29  Petasis George  <petasis@iit.demokritos.gr>
        * tcl-conf: Added a quick check to locate tclConfig.sh & tkConfig.sh,
        if they have been placed in non-standard locations withing the Tcl
        installtion directory. Bug #18
        (https://github.com/petasis/tkdnd/issues/18).

2018-06-25  Petasis George  <petasis@iit.demokritos.gr>
        * Makefile.in: Updated to latest Makefile.in from Tcl sample extension.

        * tcl-conf: Convert path returned by [info library] into an absolute
        path.

2018-06-25  Petasis George  <petasis@iit.demokritos.gr>
        * configure: Regenerated with "autoconf -i".

        * tclconfig/tcl.m4: Updated to the latest TEA version.

        * README.md: Updated the readme file with installtion instructions for
        Windows.

2018-05-26  Petasis George  <petasis@iit.demokritos.gr>
        * configure: Regenerated with "autoconf -i".

        * tclconfig/tcl.m4: Updated to the latest version.

        * configure.ac: Removed option "-fobjc-gc" from OS X build.

        * win/OleDND.h: Added the option to skip some events during DragOver().
        To activate it, DND_DRAGOVER_SKIP_EVENTS must be defined.

        * library/tkdnd_windows.tcl: Changed "update" to "update idletasks".
        Bug reported by flopp Github user.
        Bug #17: https://github.com/petasis/tkdnd/issues/17.

        * win/TkDND_OleDND.cpp: Fixed a bug in TKDND_REPORT_ERROR(x), where the
        errmsg pointer could go out of scope. Bug and patch provided by ralfixx
        Github user. Bug #18: https://github.com/petasis/tkdnd/issues/18.

        * Makefile.in: Added a fix for .cpp files, compiled under windows with
        configure/make. Bug and patch provided by ralfixx
        Github user. Bug #18: https://github.com/petasis/tkdnd/issues/18.

2018-02-19  Petasis George  <petasis@iit.demokritos.gr>
        configure.ac: "${TEA_PLATFORM}" = "windows" fails under MINGW64.
        Added a check for TEA_PLATFORM to include also MINGW64
        (windows|*MINGW64_*).

        * library/tkdnd_compat.tcl: Fixed a bug in compat::bindsource2,
        suggested by segalion: https://github.com/petasis/tkdnd/issues/13
        (The bug was that compat::bindsource2 called
        ::tkdnd::drag_source register with event 2.)

2018-02-13  Petasis George  <petasis@iit.demokritos.gr>
        * configure:
        * configure.ac:
        * configure.in:
        * tclconfig/tcl.m4: Updated to latest TEA.

        * macosx/macdnd.m:
        * unix/TkDND_XDND.c: Tcl 9.0 seems to not define any more "CONST", thus
        add this definition if it is missing (defined to "const").

2018-01-16  Petasis George  <petasis@iit.demokritos.gr>
        * win/TkDND_OleDND.h: Made destructors in all classes virtual.

        * win/TkDND_OleDND.cpp: Fixes for C++ warnings (which does not allow to
        pass a static string to Tcl_SetResult()).

        * CMakeLists.txt: Added support for building with msys2 & gcc under
        windows.

2017-08-25  Petasis George  <petasis@iit.demokritos.gr>
        * CMakeLists.txt: Added support for -Dwith-tcl, -Dwith-tclsh.

2017-01-25  Petasis George  <petasis@iit.demokritos.gr>
        * win\OleDND.cpp: Fixed a memory leak on the pDropTarget object in
        TkDND_RegisterDragDropObjCmd. Added calls to RevokeDragDrop on window
        destroy.

2017-01-20  Petasis George  <petasis@iit.demokritos.gr>
        * configure.in:
        * CMakeLists.txt:
        * library\tkdnd_windows.tcl:
        * win\OleDND.h: Added support fot type UniformResourceLocator under
        Windows.

2015-07-07  Petasis George  <petasis@iit.demokritos.gr>
        TkDND 2.8 released.

2015-07-06  Petasis George  <petasis@iit.demokritos.gr>
        * Makefile.in:
        * doc/tkDND.htm:
        * doc/tkDND.n:
        * macosx/macdnd.m:
        * unix/tkUnixSelect.c: Applied two patches from Andrew Murray,
        regarding various fixes (various typos and unused variable warnings
        under OS X).

2015-04-13  Petasis George  <petasis@iit.demokritos.gr>
        * library\tkdnd_generic.tcl: Fixed SF bug #30: Toplevel Widget Cannot
        Be Drop Target. Bug reported by Tim Tomkinson.

2015-03-04  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd.tcl: Added support in <<DragInitCmd>> & <<DragEndCmd>>
        for %x, %y mouse coordinates (relative to window that is the drag
        source). Added the ability to stop a drag on the drag source. The
        <<DragInitCmd>> binding must return either "refuse_drop"
        as a value (instead of a list), or use
        "return -code break"|"return -code continue".

2015-02-20  Petasis George  <petasis@iit.demokritos.gr>
        * unix/TkDND_XDND.c: Fixed a bug in converting Time to a Tcl object.
        Now Tcl_NewWideIntObj() is used, as Tcl_NewLongObj() could cause an
        overflow under some operating systems. Bug reported by Nicolas Bats,
        for OS X 10.7.

2014-11-26  Petasis George  <petasis@iit.demokritos.gr>
        TkDND 2.7 released.

2014-10-07  Petasis George  <petasis@iit.demokritos.gr>
        * macosx/macdnd.m:
        * library/tkdnd_macosx.tcl: Added support for DND_HTML in OS X.

        * library/tkdnd_unix.tcl: Added support for DND_HTML in XDND.

2014-09-21  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_macosx.tcl:
        * library/tkdnd_unix.tcl: Changed implementation to re-use the
        generic implementation.

        * library/tkdnd_generic.tcl: Two new procedures,
        generic::GetWindowCommonTypes and generic::FindWindowWithCommonTypes.
        The last one tries to find a window that can accept the current drag.

        * unix/TkDND_XDND.c: Fixed a bug in getting the "accepted" field
        in XdndFinished.

        * demos/overlapping_targets.tcl: New demo (more a "testing" utility for
        mega-widget support).

        * CMakeLists.txt:
        * configure.in: Updated installed files.

        * demos/basic.tcl:
        * demos/dndSpy.tcl:
        * demos/simple_target.tcl: Bug fixes.

        * library/tkdnd.tcl:
        * library/tkdnd_macosx.tcl:
        * library/tkdnd_unix.tcl: Various bug fixes.

        * win/OleDND.h:
        * win/TkDND_OleDND.cpp:
        * library/tkdnd_windows.tcl: Changed implementation to re-use the
        generic implementation.

        * library/tkdnd_generic.tcl: Added a new "generic" implementation of
        handling drops, with the aim to be re-used by all supported platforms.

2014-08-19  Petasis George  <petasis@iit.demokritos.gr>
        * unix/TkDND_XDND.c:
        * win/OleDND.h: Corrected behaviour when mouse drags over overlapping
        windows. Bug reported by Csaba Nemethi.

2014-08-13  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_windows.tcl:
        * library/tkdnd.tcl:
        * library/tkdnd_unix.tcl:
        * library/tkdnd_macosx.tcl:
        * macosx/macdnd.m: Added support for complex sources under OS X.

        * CMakeLists.txt: A few fixes for OS X.

        * demos/complex_source.tcl:
        * demos/simple_source.tcl: Ensure returned paths are absolute (to avoid
        warnings under OS X).

2014-08-06  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_unix.tcl: Added support for sources with multiple
        and (incompatible) types under Unix. Completed implementation started
        on 2014-01-05 for Windows. OS X support is still pending.

        * unix/TkDND_XDND.c: Replaced calls to (deprecated)
        XKeycodeToKeysym(), with calls to XGetKeyboardMapping().

2014-08-04  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_unix.tcl: Fixed a bug where successive drags may
        be canceled, by a delayed XDNDFinished event, which is scheduled by
        xdnd::_SendXdndDrop to occur after 10 seconds (as a protection against
        a failed selection transfer by the client).
        Bug reported by Csaba Nemethi.

2014-01-05  Petasis George  <petasis@iit.demokritos.gr>
        * doc/tkDND.n: Updated the man page.

        * demos/complex_source.tcl:
        * demos/simple_source.tcl:
        * demos/simple_target.tcl: New demos.

        * win/OleDND.h:
        * win/TkDND_OleDND.cpp:
        * library/tkdnd.tcl:
        * library/tkdnd_windows.tcl: Added support for sources with multiple
        and (incompatible) types, that require different data to be dropped. The
        changes affect the <<DragInitCmd>>, where there are now to types of
        return values expected from the event. Changes have been tested only
        under Windows. Unix/OS X not yet implemented.

        * demos/basic.tcl: Added information about the cross-platform dropped
        type.

2012-11-27  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_unix.tcl:
        * library/tkdnd_windows.tcl: Leave and Drop events do not report 0
        as root x/y (%X %Y). In case the underlying protocol does not support
        reporting the mouse coordinates for the specific event, the last known
        position from the position event is used.

2012-08-26  Petasis George  <petasis@iit.demokritos.gr>
        TkDND 2.6 released.
        * unix/tkUnixSelect.c: Added a work-around for getting the selection
        under unix: since Tk does not always deliver SelectionNotify, we try
        to get the selection even if SelectionNotify has not been received.

2012-08-15  Petasis George  <petasis@iit.demokritos.gr>
        * unix/tkUnixSelect.c: Partially solved the problem with getting
        selection under unix. The solution was to try and get the selection,
        even if a SelectionNotify event has not been delivered.

2012-07-14  Petasis George  <petasis@iit.demokritos.gr>
        * unix/tkUnixSelect.c: Tests with Tcl_ThreadAlert(). It helps
        somewhat, but is not the solution for the problems when getting the
        selection.

2012-06-17  Petasis George  <petasis@iit.demokritos.gr>
        TkDND 2.5 released.
        * win/TkDND_OleDND.cpp: Fixes for type CF_HDROP.

2012-06-07  Petasis George  <petasis@iit.demokritos.gr>
        * demos/basic.tcl: Updated demo with support for colours, which only
        works for XDND right now.

        * unix/TkDND_XDND.c:
        * unix/tkUnixSelect.c: Implementation of unix (XDND) drags completed.

2012-06-06  Petasis George  <petasis@iit.demokritos.gr>
        * unix/Cursors.c: Ported cursors from TkDND 1.x to TkDND 2.x

2012-06-05  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd.tcl:
        * library/tkdnd_unix.tcl:
        * unix/tkUnixSelect.c:
        * unix/TkDND_XDND.c: Added support for initiating drags from Tk under
        unix. Despite incomplete, seems to work with GTK.

2012-06-02  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_unix.tcl:
        * unix/TkDND_XDND.c:
        * unix/tkUnixSelect.c:
        * unix/tkSelect.h: Modifications to support Linux drops. Drops from
        GTK seem to always work, and drops from Qt seem to work most of the
        times.

2012-04-19  Petasis George  <petasis@iit.demokritos.gr>
        * win/Makefile: Updated the Windows Makefile, after a patch from
        Dave Bodenstab.

2012-04-12  Petasis George  <petasis@iit.demokritos.gr>
        TkDND 2.4 released.
        * library/tkdnd_unix.tcl:
        * unix/TkDND_XDND.c:
        * unix/tkUnixSelect.c:
        * unix/tkSelect.h: Modifications to support Linux drops.

        * tclconfig/*:
        * configure.in, Makefile.in: Updated to TEA 3.9.

        * library/tkdnd_unix.tcl: Removed braces from a comment in
        xdnd::_GetDroppedData, left from testing with TIP 370 preliminary
        implementation. SF Bug ID: 3516862

2012-03-03  Petasis George  <petasis@iit.demokritos.gr>
        TkDND 2.3 released.
        * library/tkdnd_windows.tcl:
        * win/OleDND.h:
        * win/TkDND_OleDND.cpp: Fix in TkDND_DropSource::QueryContinueDrag,
        to support dragging with all mouse buttons. Bug reported by
        Michael Fersch.

2011-09-24  Petasis George  <petasis@iit.demokritos.gr>
        * win/OleDND.h: Added definition of WINVER to version 5, when compiling
        with MinGW, which defines it with version 4. SF Bug ID: 3411338.

2011-09-23  Petasis George  <petasis@iit.demokritos.gr>
        * win/OleDND.h: Modified STRING_(s), to ease compilation with MinGW.
        Patch provided by Hans-Christoph Steiner. SF Bug ID: 3411338.

2011-09-22  Petasis George  <petasis@iit.demokritos.gr>
        * win/OleDND.h: Added a check if CF_DIBV5 is defined (i.e.
        WINVER < 0x0500). SF Bug ID: 3411338.

2011-03-18  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_unix.tcl: Fixed a bug in xdnd::_GetDroppedData, where
        an improper error was thrown in case no common types were found between
        the drag source and drop target widgets. Now a more appropriate error
        is returned. Bug reported by Kevin Walzer.

2011-01-14  Petasis George  <petasis@iit.demokritos.gr>
        * library/tkdnd_unix.tcl: Added support for accepting drops, if
        TIP 370 is finally approved. Changes tested with a preliminary TIP 370
        implementation.

        * library/tkdnd_macosx.tcl: Fixed a bug reported by Kevin Walzer:
        macdnd::_GetDroppedData and xdnd::_GetDroppedData were missing the
        "time" argument, added in the XDND section for TIP 370 (if it gets
        accepted).

        * macosx/macdnd.m: Restored back a workaround by Kevin Walzer, as
        TkDND does not work well under all circumstances in OS X 10.6.
        (Reported by Kevin Walzer on 23 Dec 2010).

2010-08-03  Petasis George  <petasis@iit.demokritos.gr>
        TkDND 2.2 released.
        * library/tkdnd_windows.tcl:
        * win/OleDND.h: Fixes for compiling with UNICODE & _UNICODE.

2010-07-28  Petasis George  <petasis@iit.demokritos.gr>
        * win/Makefile: Updated.

        * library/tkdnd_unix.tcl:
        * library/tkdnd_windows.tcl: Fixed bug 2169256.

        * library/tkdnd.tcl: Fixed bug 2486830.

2010-06-16  Petasis George  <petasis@iit.demokritos.gr>
        * Makefile.in:
        * configure.in:
        * win/Makefile:
        * win/TkDND_OleDND.cpp:
        * unix/TkDND_XDND.c: Applied a patch from Andreas Kupries, which
        make the unix code compatible with compilers supporting C89 (i.e.
        AIX's cc). Also, the TEA files were updated.

        * /unix/TkDND_XDND.c: Fixed a bug in TkDND_RegisterTypesObjCmd.
        It seems that KDE wants the XdndAware property on the window these
        days, and not at the toplevel one.

2010-06-11  Petasis George  <petasis@iit.demokritos.gr>
        TkDND 2.1 released.

2010-05-05  Petasis George  <petasis@iit.demokritos.gr>
        * /macosx/macdnd.m: Several fixes. The most important are:
        Do not initiate a drag if the clipboard is empty (i.e. because we
        cannot handle any of the provided types).
        Fixed drag icon slide when the drag is canceled.

2010-04-30  Petasis George  <petasis@iit.demokritos.gr>
        * /macosx/macdnd.m: Several changes:
        Moved drag operation inside TkDND_DoDragDropObjCmd. This means that
        drag operation can be started with a Tk binding.
        Fixed the way drag types are declared in the drag clipboard. Now types
        are reported correctly during drops.
        Added a tag in the DNDView class.
        Added a function to get the DNDView pointer from an NSView pointer.
        Hopefully this will not permit to add more than one DNDView to any
        view. This function always return a DNDView pointer (it creates a
        new DNDView if a view does not already has one).

        The demos seem to work, although the garbage collector seems to print
        some messages during drags from Tk windows.

2010-04-06  Petasis George  <petasis@iit.demokritos.gr>
        * /macosx/macdnd.m: Some attempts towards drag support for OS X.

2010-01-03  Petasis George  <petasis@iit.demokritos.gr>
        * /library/tkdnd_macosx.tcl:
        * /macosx/macdnd.m: Changed the way dropped data is handled: during
        the drop event the data are converted into a utf-8 string (in case of
        dropping string data) or a Tcl list object of utf-8 filenames (in case
        of dropping files). The data object is stored directly in the
        tkdnd::macdnd::_dropped_data variable, instead of the selection
        clipboard. _GetDroppedData was modified to return this stored data.

2009-12-30  Petasis George  <petasis@iit.demokritos.gr>
        * /cmake:
        * /CMakeLists.txt: Added support for building TkDND with cmake (i.e.
        under windows).

2009-12-29  Petasis George  <petasis@iit.demokritos.gr>
        * /library/tkdnd_macosx.tcl:
        * /macosx/macdnd.m: Changes to better integrate the work done by
        Kevin Walzer with the rest of TkDND, since OS X seems to mimic the
        XDND implementation. tkdnd_macosx.tcl is now a stub file, with most of
        the work being done by the unix (XDND) code.
        I think that OS X drop support is now working.

2009-12-09  Petasis George  <petasis@iit.demokritos.gr>
        * /library/tkdnd_macosx.tcl:
        * /macosx/macdnd.m: Updates to better integrate the OS X type
        registration command with the rest of the TkDND internal API.

2009-12-01  Walzer Kevin    <kw@codebykevin.com>
        * /macosx/*: Initial support for drop targets under OS X (Cocoa).

2007-02-09  Petasis George  <petasis@iit.demokritos.gr>
        * /unix/TkDND_XDND.c: Fixed a bug in TkDND_RegisterTypesObjCmd, where
        Tk_Parent was used to determine if a provided path was a toplevel.
        Replaced by a check through Tk_IsTopLevel.
        Bug reported by Alain Bertrand <alain.mp.bertrand@tele2.be>

2006-04-24  Petasis George  <petasis@iit.demokritos.gr>
        * TkDND version 2.0 started.
